import {NetworkingV1Api} from "@kubernetes/client-node";
import {kc} from "./kubeConfig";

const network = kc.makeApiClient(NetworkingV1Api);

export type Service = {
    name: string,
    port: number,
}

let ingresses: {[key: string]: Service[]} = {}
async function parseIngress() {
    const readIngresses= await network.listNamespacedIngress('default')
    const mapped = readIngresses.body.items.flatMap(ingress=>{
        return ingress.spec?.rules?.map(rule=>{
            const host = rule.host;
            return [host, [...new Set(rule. http!.paths!.map(path=>({name: path.backend.service!.name!, port: path.backend.service!.port!.number!})))]]
        })
    }).filter(item=>item).map(item=>item as [string, Service[]])
    ingresses = Object.fromEntries(mapped)
    console.log(ingresses)
}
setInterval(parseIngress, 60000);
parseIngress();

export function getIngress(host: string): Service[] | undefined {
    return ingresses[host];
}
