import {addListener} from "./logStream";
import {markVisited} from "./markVisited";
import {system} from "./systems/system";

export function startLogParser() {
    addListener(chunk => {
        const lines = Buffer.from(chunk).toString().split('\n')
        lines.forEach(line=>{
            if(!line) return;
            system.lineReceived(line)?.forEach(markVisited)
        })
    })
}
