import {kc} from "../kubeConfig";
import {VersionApi} from "@kubernetes/client-node";
import {Service} from "../ingress";
import {K3s} from "./k3s";
import {MicroK8s} from "./MicroK8s";

const versionApi = kc.makeApiClient(VersionApi);
export let system: System;
export const systemPromise: Promise<void> = new Promise(async resolve=>{
    const response = await versionApi.getCode()
    const version = response.body.gitVersion;
    if(version.includes('k3s')) system = new K3s();
    else system = new MicroK8s();
    resolve();
});

export interface System {
    lineReceived(text: string): Service[] | string[] | undefined;
    traefikNamespace: string;
}
